<?php
/**
* Joomla Community Builder : Plugin Handler
* @version $Id: plugin.class.php 557 2006-11-18 02:52:59Z beat $
* @package Community Builder
* @subpackage plugin.class.php
* @author various, JoomlaJoe and Beat
* @copyright (C) JoomlaJoe and Beat, www.joomlapolis.com and various
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mainframe;
$domitPath = $mainframe->getCfg('absolute_path') . '/includes/domit/xml_domit_lite_include.php';
if ( file_exists( $domitPath ) ) {
	require_once( $domitPath );
} else {
	die("<font color='red'>".$mosConfig_absolute_path . "/includes/domit/ does not exist! This is normal with mambo 4.5.0 and 4.6.1. Community Builder needs this library for handling plugins.<br />  You Must Manually do the following:<br /> 1.) create ".$mosConfig_absolute_path . "/includes/domit/ directory <br /> 2.) chmod it to 777 <br /> 3.) copy corresponding content of a mambo 4.5.2 directory.</font><br /><br />\n");
}

if (is_callable("jimport")) {
	jimport('joomla.filesystem.*');
}


/** utility: checks if all elements of array needles are in array haystack */
function all_in_array($needles,$haystack) {
	if (is_array($needles)) {
		foreach ($needles as $needle) {
			if (!in_array($needle,$haystack)) return false;
		}
	} else {
		if (!in_array($needles,$haystack)) return false;
	}
	return true;
}

/** utility: adds all vars of object $src to object $obj except the variable named in array exclude Array */
function addVarsToClass(&$obj,$src,$excludeArray) {
	foreach(get_object_vars($src) as $key => $val) {
		if(!in_array($key,$excludeArray)) {
			$obj->$key = $val;
		}
	}	
}

class cbPluginHandler {
	/** @var array An array of functions in event groups */
	var $_events=null;
	/** @var array An array of menu and status items (array) */
	var $_menus=null;
	/** @var array An array of lists */
	var $_lists=null;
	/** @var array An array of loaded plugins objects, index=pluginId */
	var $_plugins=null;
	/** @var array An array indexed by the group-name of arrays of plugin ids of the plugins already loaded */
	var $_pluginGroups=array();
	/** @var int Index of the plugin being loaded */
	var $_loading=null;
	/** @var array collection of debug data */
	var $debugMSG=array();
	/** @var string Error Message*/
	var $errorMSG=array();
	var $_iserror=false;
	var $params=null;	
	
	/**
	* Constructor
	*/
	function cbPluginHandler() {
		$this->_events = array();
	}
	/**
	* Loads all the bot files for a particular group (if group not already loaded)
	* @param string The group name, relates to the sub-directory in the plugins directory
	* @param mixed array of int : ids of plugins to load. OR: string : name of class 
	* @param int if 1 (DEFAULT): load only published plugins, if 0: load all plugins including unpublished ones
	* @return boolean TRUE: load done, FALSE: no plugin loaded
	*/
	function loadPluginGroup( $group,$ids=null, $publishedStatus=1 ) {
		global $database, $my;
		
		if (!isset($this->_pluginGroups[$group]) || !all_in_array($ids, $this->_pluginGroups[$group])) {
			if ($ids === null) $where = "";
			elseif (count($ids)>=1) $where = "AND id IN (".implode(",",$ids).")";
			$group = trim( $group );
			if ( $publishedStatus == 1 ) {
				$published = "= 1";
			} else {
				$published = ">= " . (int) $publishedStatus;
			}
			$database->setQuery( "SELECT id,folder, element, published,type,params, CONCAT_WS('/',folder,element) AS lookup"
			. "\n FROM #__comprofiler_plugin"
			. "\n WHERE published " . $published . " AND access <= ". (int) $my->gid . " AND type='$group' $where "
			. "\n ORDER BY ordering"
			);
			if (!($plugins = $database->loadObjectList())) {
				//echo "Error loading Plugins: " . $database->getErrorMsg();
				return false;
			}
			foreach ($plugins AS $plugin) {
				if (!isset($this->_pluginGroups[$group][$plugin->id]) && $this->_loadPluginFile($plugin))
				{
					$this->_pluginGroups[$group][$plugin->id]=$plugin->id;
				}
			}
		}
		return true;
	}
	function _loadPluginFile($plugin) {
		global $mainframe,$_PLUGINS;
		
		$path = $mainframe->getCfg('absolute_path') . '/components/com_comprofiler/plugin/' . $plugin->type . '/'. $plugin->folder . '/' . $plugin->element . '.php';
		if (file_exists( $path )) {
			$this->_loading = $plugin->id;
			$this->_plugins[$plugin->id] = $plugin;
			require_once( $path );
			$this->_loading = null;
			return true;
		} else {
			return false;
		}
	}
	function _loadParams($pluginid, $extraParams=null) {
		global $_PLUGINS;
		$this->params=new cbParameters($_PLUGINS->_plugins[$pluginid]->params . "\n" . $extraParams);	
	}
	function getParams() {
		return $this->params;
		
	}
	function _internalPLUGINSaddMenu( $menuItem ) {
		$this->_menus[] = $menuItem;
	}
	/**
	* Registers a menu or status item to a particular menu position
	* @param array a menu item like:
		// Test example:
		$mi = array(); $mi["_UE_MENU_CONNECTIONS"]["duplique"]=null;
		$this->addMenu( array(	"position"	=> "menuBar" ,		// "menuBar", "menuList"
									"arrayPos"	=> $mi ,
									"caption"	=> _UE_MENU_MANAGEMYCONNECTIONS ,
									"url"		=> sefRelToAbs($ue_manageConnection_url) ,		// can also be "<a ....>" or "javascript:void(0)" or ""
									"target"	=> "" ,	// e.g. "_blank"
									"img"		=> null ,	// e.g. "<img src='plugins/user/myplugin/images/icon.gif' width='16' height='16' alt='' />"
									"alt"		=> null ,	// e.g. "text"
									"tooltip"	=> _UE_MENU_MANAGEMYCONNECTIONS_DESC ,
									"keystroke"	=> null ) );	// e.g. "P"
		// Test example: Member Since:
		$mi = array(); $mi["_UE_MENU_STATUS"]["_UE_MEMBERSINCE"]["dupl"]=null;
		$dat = cbFormatDate($user->registerDate);
		if (!$dat) $dat="?";
		$this->addMenu( array(	"position"	=> "menuList" ,		// "menuBar", "menuList"
									"arrayPos"	=> $mi ,
									"caption"	=> $dat ,
									"url"		=> "" ,		// can also be "<a ....>" or "javascript:void(0)" or ""
									"target"	=> "" ,	// e.g. "_blank"
									"img"		=> null ,	// e.g. "<img src='plugins/user/myplugin/images/icon.gif' width='16' height='16' alt='' />"
									"alt"		=> null ,	// e.g. "text"
									"tooltip"	=> _UE_MEMBERSINCE_DESC ,
									"keystroke"	=> null ) );	// e.g. "P"
	*/
	function addMenu( $menuItem ) {
		global $_PLUGINS;
			$_PLUGINS->_internalPLUGINSaddMenu($menuItem);
	}
	/**
	* Returns all menu items registered with addMenu
	* @param string The event name
	* @param string The function name
	*/
	function getMenus() {
		return $this->_menus;
	}
	/**
	* Registers a function to a particular event group
	* @param string The event name
	* @param string The function name
	*/
	function registerFunction( $event, $method, $class=null ) {
		$this->_events[$event][] = array( $class,$method, $this->_loading );
	}
	/**
	* Calls all functions associated with an event group
	* @param string The event name
	* @param array An array of arguments
	* @param boolean True is unpublished bots are to be processed
	* @return array An array of results from each function call
	*/
	function trigger( $event, $args=null ) {
		$result = array();

		if ($args === null) {
			$args = array();
		}
		if (isset( $this->_events[$event] )) {
			foreach ($this->_events[$event] as $func) {
				$result[]=$this->call($func[2],$func[1],$func[0],$args);
			}
		}
		return $result;
	}
	function is_errors() {
		return $this->_iserror;
	}
	/**
	* Execute the plugin class/method pair
	* @param int id of plugin
	* @param string name of plugin variable
	* @param mixed value to assign (if any)
	* @return mixed : previous value
	*/
	function plugVarValue($pluginid, $var, $value=null) {
		$preValue = $this->_plugins[$pluginid]->$var;
		if ($value !== null) $this->_plugins[$pluginid]->$var = $value;
		return $preValue;
	}
	/**
	* Execute the plugin class/method pair
	* @param int id of plugin
	* @param string name of plugin method
	* @param string name of plugin class
	* @param array set of variables to path to class/method
	* @param string additional parameters external to plugin params (e.g. tab params)
	* @return mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function call($pluginid, $method, $class, &$args, $extraParams=null) {
		if ($class!=null && class_exists($class)) {
			if ($this->_plugins[$pluginid]->published) {
				if (!isset($this->_plugins[$pluginid]->classInstance[$class])) {
					if (!isset($this->_plugins[$pluginid]->classInstance)) {
						$this->_plugins[$pluginid]->classInstance = array();
					}
					$this->_plugins[$pluginid]->classInstance[$class] = new $class();
				}
				if (method_exists( $this->_plugins[$pluginid]->classInstance[$class],$method )) {
					$this->_plugins[$pluginid]->classInstance[$class]->_loadParams($pluginid, $extraParams);
					addVarsToClass($this->_plugins[$pluginid]->classInstance[$class], $this->_plugins[$pluginid], array("params"));
					return call_user_func_array(array(&$this->_plugins[$pluginid]->classInstance[$class],$method), $args);
				} 
			}
		} elseif (function_exists( $method )) {
			if ($this->_plugins[$pluginid]->published) {
				$this->_loadParams($pluginid, $extraParams);
				return call_user_func_array( $method, $args );
			} 
		}
		return false;
	}
	/**
	* Gets a variable from the plugin class
	* @param int id of plugin
	* @param string name of plugin class
	* @param string name of class variable
	* @return mixed : variable's content
	*/
	function getVar($pluginid, $class, $variable) {
		if ($class!=null && class_exists($class)) {
			if ($this->_plugins[$pluginid]->published) {
				if (isset( $this->_plugins[$pluginid]->classInstance[$class]->$variable )) {
					return $this->_plugins[$pluginid]->classInstance[$class]->$variable;
				} 
			}
		}
		return false;
	}

	/**
	* Gets the text of the last error
	* @return string text for error message
	*/
	function getErrorMSG($separator='\n') {
		$error=null;
		if(count($this->errorMSG)>0) {
			$errs=$this->errorMSG;
			foreach($errs AS $err) {
				$error .= $err.$separator;
			}
		}	
		return $error;
	}
	/**
	* PRIVATE method: sets the text of the last error
	* @param string error message
	* @return boolean true
	*/
	function _setErrorMSG($msg) {
		$this->errorMSG[]=$msg;
		return true;
	}
	/**
	* PRIVATE method: sets the error condition and priority (for now 0)
	* @param error priority
	* @return boolean true
	*/	
	function raiseError($priority) {
		$this->_iserror=true;	
		return true;
	}
	
	/**
	* Gets the debug text
	* @returns string text for debug
	*/
	function getDebugMSG() {
		return $this->debugMSG;
	}
	/**
	* PRIVATE method: sets the text of the last error
	* @returns void
	*/
	function _setDebugMSG($method,$msg) {
		$debugARRAY=array();
		$debugARRAY['class']=get_class($this);
		$debugARRAY['method']=$method;
		$debugARRAY['msg']=$msg;
		$this->debugMSG[]=$debugARRAY;
		return true;
	}
}	// end class cbPluginHandler

/**
* Event Class for handling the CB event api
* @package Community Builder
* @author JoomlaJoe
*/
class cbEventHandler extends cbPluginHandler  {

	/**
	* Constructor
	*/
	function cbEventHandler() {
		$this->cbPluginHandler();
	}
}

/**
* Tab Class for handling the CB tab api
* @package Community Builder
* @author JoomlaJoe and Beat
*/
class cbTabHandler extends cbPluginHandler  {
	var $fieldJS="";

	/**
	* Constructor
	*/
	function cbTabHandler() {
		$this->cbPluginHandler();
	}
	/**
	* Generates the menu and user status to display on the user profile by calling back $this->addMenu
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns boolean : either true, or false if ErrorMSG generated
	*/
	function getMenuAndStatus($tab,$user,$ui) {
	}
	/**
	* Generates the HTML to display the user profile tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayTab($tab, $user, $ui) {
	}
	/**
	* Generates the HTML to display the user edit tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getEditTab($tab, $user, $ui) {
	}
	/**
	* Saves the user edit tab postdata into the tab's permanent storage
	* @param object tab reflecting the tab database entry (incl. id. Will be stored after returning)
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @param array _POST data for saving edited tab content as generated with getEditTab
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function saveEditTab($tab, &$user, $ui, $postdata) {
	}
	/**
	* Generates the HTML to display the registration tab/area
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayRegistration($tab, $user, $ui) {
	}
	/**
	* Saves the registration tab/area postdata into the tab's permanent storage
	* @param object tab reflecting the tab database entry (incl. id. Will be stored after returning)
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @param array _POST data for saving edited tab content as generated with getEditTab
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function saveRegistrationTab($tab, &$user, $ui, $postdata) {
	}
	/**
	* WARNING: UNCHECKED ACCESS! On purpose unchecked access for M2M operations
	* Generates the HTML to display for a specific component-like page for the tab. WARNING: unchecked access !
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @param array _POST data for saving edited tab content as generated with getEditTab
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated, or null if nothing to display
	*/
	function getTabComponent($tab, $user, $ui, $postdata) {
		return null;
	}
	//
	// private methods for inheriting classes:
	//
	/**
	* adds a validation JS code for the Edit Profile and Registration pages
	* @param string Javascript code ready for HTML output, with a tab \t at the begin and a newline \n at the end.
	*/
	function _addValidationJS($js)
	{
		$this->fieldJS .= $js;
	}
	/**
	* internal utility method
	* @param string postfix for identifying multiple pagings/search/sorts (optional)
	* @returns string value of the tab forms&urls prefix
	*/
	function _getPrefix($postfix="")
	{
		return str_replace(".","_",((strncmp($this->element, "cb.", 3)==0)? substr($this->element,3) : $this->element).$postfix);
	}
	/**
	* gets an ESCAPED and urldecoded request parameter for the plugin
	* @param string name of parameter in REQUEST URL
	* @param string default value of parameter in REQUEST URL if none found
	* @param string postfix for identifying multiple pagings/search/sorts (optional)
	* @return string value of the parameter (urldecode processed for international and special chars) and ESCAPED! and ALLOW HTML!
	*		you need to call stripslashes to remove escapes, and htmlspecialchars before displaying.
	*/
	function _getReqParam($name, $def=null, $postfix="")
	{
		global $_GET, $_POST;
		$prefix = $this->_getPrefix($postfix);
		if (isset($_POST[$prefix.$name])) {
			return cbGetEscaped($_POST[$prefix.$name]);
		} else if (isset($_GET[$prefix.$name])) {
			return utf8ToISO(urldecode(cbGetEscaped($_GET[$prefix.$name])));
		} else {
			return $def;
		}
	}
	/**
	* gets the name input parameter for search and other functions
	* @param string name of parameter of plugin
	* @param string postfix for identifying multiple pagings/search/sorts (optional)
	* @returns string value of the name input parameter
	*/
	function _getPagingParamName($name="search", $postfix="")
	{
		$prefix = $this->_getPrefix($postfix);
		return $prefix.$name;
	}
	/**
	* gives the URL of a link with plugin parameters.
	* @param array of string with key name of parameters
	* @param string cb task to link to (default: userProfile)
	* @param boolean TRUE to call sefRelToAbs (default), FALSE to leave URL unsefed
	* @param array of string with keys of parameters to not include
	* @return string value of the parameter
	*/
	function _getAbsURLwithParam($paramArray, $task="userProfile", $sefed=true,$excludeParamList=array())
	{
		global $_POST, $_GET, $database;
		
		$prefix = $this->_getPrefix();
		
		if (isset($paramArray["Itemid"])) {
			$Itemid = $paramArray["Itemid"];
			unset($paramArray["Itemid"]);
		} else if(isset($_POST['Itemid'])) {
			$Itemid = cbGetParam($_POST,'Itemid',null);
		} else if(isset($_GET['Itemid'])) {
			$Itemid = cbGetParam($_GET,'Itemid',null);
		} else {
			$database->setQuery("SELECT id FROM #__menu WHERE link = 'index.php?option=com_comprofiler' AND published=1");
			$Itemid = $database->loadResult();
		}
		if ($task=="userProfile" && !isset($paramArray["user"])) {
			if (isset($_POST['user'])) {
				$paramArray["user"] = urldecode(cbGetParam($_POST,'user',null));
			} else {
				$paramArray["user"] = urldecode(cbGetParam($_GET,'user',null));
			}
		}
		if (!isset($paramArray["tab"])) {
	/*		if (isset($_POST['tab'])) {
				$paramArray["tab"] = cbGetParam($_POST,'tab',null);
			} else if (isset($_GET['tab'])) {
				$paramArray["tab"] = urldecode(cbGetParam($_GET,'tab',null));
			} else {
	*/
				$paramArray["tab"] = strtolower(get_class($this));
	//		}
		}
		$uri = "index.php?option=com_comprofiler&amp;task=".$task
			.($paramArray["user"] ? '&amp;user='.htmlentities(stripslashes($paramArray["user"])) : '')
			.($Itemid ? '&amp;Itemid='.$Itemid : '')
			.($paramArray["tab"] ? '&amp;tab='.htmlentities(stripslashes($paramArray["tab"])) : '');
		reset($paramArray);
		while (list($key, $val) = each($paramArray)) {
			if (!in_array($key,array("Itemid","user","tab")) && !in_array($key,$excludeParamList)) {
				if ($val) $uri .= "&amp;".htmlentities($prefix.$key)."=".htmlentities(stripslashes($val));
			}
		}
		if ($sefed) return sefRelToAbs($uri);
		else return $uri;
	}
	/**
	* Writes the html search box as <form><div><input ....
	* @param array: paging parameters. ['limitstart'] is the record number to start dislpaying from will be ignored
	* @param string postfix for identifying multiple pagings/search/sorts (optional)
	* @param string the class/style for the div
	* @param string the class/style for the input
	* @param string cb task to link to (default: userProfile)
	* @return string html text displaying a nice search box
	*/
	function _writeSearchBox($pagingParams,$postfix="",$divClass="style=\"float:right;\"",$inputClass="class=\"inputbox\"",$task="userProfile")
	{
		$base_url = $this->_getAbsURLwithParam($pagingParams, $task, true, array($postfix."search",$postfix."limitstart"));
		$searchPagingParams = stripslashes($pagingParams[$postfix."search"]);

		$searchForm = "<form action=\"".$base_url."\" method=\"post\"><div".($divClass?" ".$divClass:"").">";
/* done in _getAbsURLwithParam:
		foreach ($pagingParams as $k => $pp) {
			if ($pp && !in_array($k,array($postfix."search",$postfix."limitstart"))) {
				$searchForm .= "<input type='hidden' name='".$this->_getPagingParamName($k)."' value=\"".htmlspecialchars($pp)."\" />";	//BB _ISO charset into htmlspecialchars everywhere ?
			}
		}
*/
		$searchForm .= "<input type=\"text\" name=\"".$this->_getPagingParamName("search",$postfix)."\" ".$inputClass." value=\""
					.($searchPagingParams ? htmlspecialchars($searchPagingParams) : _UE_SEARCH_INPUT)."\"";
		if (!$searchPagingParams) {
			$searchForm .= " onblur=\"if(this.value=='') { this.value='"._UE_SEARCH_INPUT."'; return false; }\""
						." onfocus=\"if(this.value=='"._UE_SEARCH_INPUT."') this.value='';\"";
		}
		$searchForm .= " onchange=\"if(this.value!='".($searchPagingParams ? str_replace(array("\\","'"),array("\\\\","\\'"),htmlspecialchars($searchPagingParams)) : _UE_SEARCH_INPUT)."')"
					." { ";
		if (!$searchPagingParams) {
			$searchForm .= "if (this.value=='"._UE_SEARCH_INPUT."') this.value=''; ";
		}
		$searchForm .= "this.form.submit(); }\" />"
					. "</div></form>";
		return $searchForm;
	}
	/**
	* Writes the html links for sorting as headers
	* @param array: paging parameters. ['limitstart'] is the record number to start dislpaying from will be ignored
	* @param string postfix for identifying multiple pagings/search/sorts (optional)
	* @param string sorting parameter added as &sortby=... if NOT NULL
	* @param string Name to display as column heading/hyperlink
	* @param boolean true if it is the default sorting field to not output sorting
	* @param string class/style html for the unselected sorting header
	* @param string class/style html for the selected sorting header
	* @param string cb task to link to (default: userProfile)
	* @return string html text displaying paging
	*/
	function _writeSortByLink($pagingParams,$postfix,$sortBy,$sortName,$defaultSort=false,$unselectedClass='class="cbSortHead"',$selectedClass='class="cbSortHeadSelected"',$task="userProfile")
	{
		$url = $this->_getAbsURLwithParam($pagingParams, $task, false, array($postfix."sortby",$postfix."limitstart"));
		$prefix = $this->_getPrefix();
		//done in _getAbsURLwithParam: foreach ($pagingParams as $k => $v) if ($v && $k!=$postfix."sortby")  $url .= "&amp;".htmlentities($prefix.$k)."=".htmlentities($v);
		if (!$defaultSort) $url .= "&amp;".htmlentities($prefix.$postfix)."sortby=".htmlentities($sortBy);
		$class = ((!$pagingParams[$postfix."sortby"] && $defaultSort) || ($pagingParams[$postfix."sortby"]==$sortBy))?" ".$selectedClass:" ".$unselectedClass;
		return '<a href="'.sefRelToAbs($url).'"'.$class.' title="'.sprintf(_UE_CLICKTOSORTBY,htmlspecialchars($sortName, ENT_QUOTES)).'">'
				.htmlspecialchars($sortName, ENT_QUOTES).'</a>';
	}
	/**
	* Writes the html links for pages inside tabs, eg, previous 1 2 3 ... x next
	* @param array: paging parameters. ['limitstart'] is the record number to start dislpaying from will be ignored
	* @param string postfix for identifying multiple pagings/search/sorts (optional)
	* @param int Number of rows to display per page
	* @param int Total number of rows
	* @param string cb task to link to (default: userProfile)
	* @return string html text displaying paging
	*/
	function _writePaging($pagingParams, $postfix, $limit, $total, $task="userProfile")
	{
		$base_url = $this->_getAbsURLwithParam($pagingParams, $task, false, array($postfix."limitstart"));
		$prefix = $this->_getPrefix($postfix);
		return writePagesLinks($pagingParams[$postfix.'limitstart'], $limit, $total,$base_url,null,$prefix);
	}
	/**
	* gets the paging limitstart, search and sortby parameters, as well as additional parameters
	* @param array of string : keyed additional parameters as "Param-name" => "default-value"
	* @param mixed : array of string OR string : postfix for identifying multiple pagings/search/sorts (optional)
	* @return array("limitstart" => current list-start value (default: null), "search" => search-string (default: null), "sortby" => sorting by, +additional parameters as keyed in $additionalParams)
	*/
	function _getPaging($additionalParams=array(), $postfixArray=null)
	{
		$return=array();

		if (!is_array($postfixArray)) {
			if (is_string($postfixArray)) {
				$postfixArray = array($postfixArray);
			} else {
				$postfixArray = array("");
			}
		}
		foreach ($postfixArray as $postfix) {	
			$return[$postfix."limitstart"] = $this->_getReqParam("limitstart", null, $postfix);
			$return[$postfix."search"] = $this->_getReqParam("search", null, $postfix);
			$return[$postfix."sortby"] = $this->_getReqParam("sortby", null, $postfix);
		}
		foreach ($additionalParams as $k => $p) {
			$return[$k] = $this->_getReqParam($k, $p);
		}
		return $return;
	}
	/**
	* sets the paging limitstart, search and sortby parameters, as well as additional parameters
	* @param array of string : keyed additional parameters as "Param-name" => "value"
	* @param string search string
	* @param string sorting parameter added as &sortby=... if NOT NULL
	* @param array of string : keyed additional parameters as "Param-name" => "default-value"
	* @param string postfix for identifying multiple pagings/search/sorts (optional)
	* @return array("limitstart" => current list-start value (default: null), "search" => search-string (default: null), "sortby" => sorting by, +additional parameters as keyed in $additionalParams)
	*/
	function _setPaging($limitstart="0",$search=null,$sortBy=null,$additionalParams=array(), $postfix="")
	{
		$return=array();

		$return[$postfix."limitstart"] = $limitstart;
		$return[$postfix."search"] = $search;
		$return[$postfix."sortby"] = $sortBy;
		foreach ($additionalParams as $k => $p) {
			$return[$k] = $p;
		}
		return $return;
	}
}	// end class cbTabHandler.


/**
* PMS Class for handling the CB PMS api
* @package Community Builder
* @author Beat
*/
class cbPMSHandler extends cbTabHandler  {
	/**
	* Constructor
	*/
	function cbPMSHandler() {
		$this->cbTabHandler();
	}
	/**
	* Sends a PMS message
	* @param int userId of receiver
	* @param int userId of sender
	* @param string subject of PMS message
	* @param string body of PMS message
	* @param boolean false: real user-to-user message; true: system-Generated by an action from user $fromid (if non-null)
	* @return mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function sendUserPMS($toid, $fromid, $subject, $message, $systemGenerated=false) {
	}
	/**
	* returns all the parameters needed for a hyperlink or a menu entry to do a pms action
	* @param int userId of receiver
	* @param int userId of sender
	* @param string subject of PMS message
	* @param string body of PMS message
	* @param int kind of link: 1: link to compose new PMS message for $toid user. 2: link to inbox of $fromid user; 3: outbox, 4: trashbox,
	  5: link to edit pms options
	* @return mixed array of string {"caption" => menu-text ,"url" => NON-sefRelToAbs relative url-link, "tooltip" => description} or false and errorMSG
	*/
	function getPMSlink($toid, $fromid, $subject, $message, $kind) {
	}
	/**
	* gets PMS system capabilities
	* @return mixed array of string {"subject" => boolean ,"body" => boolean} or false if ErrorMSG generated
	*/
	function getPMScapabilites() {
	}
	/**
	* gets PMS unread messages count
	* @param	int user id
	* @return	mixed number of messages unread by user $userid or false if ErrorMSG generated
	*/
	function getPMSunreadCount($userid) {
	}
}

/**
* Installer class
* @package Community Builder
* @subpackage Installer
* @abstract
*/
class cbInstaller {
	// name of the XML file with installation information
	var $i_installfilename	= "";
	var $i_installarchive	= "";
	var $i_installdir		= "";
	var $i_iswin			= false;
	var $i_errno			= 0;
	var $i_error			= "";
	var $i_installtype		= "";
	var $i_unpackdir		= "";
	var $i_docleanup		= true;

	/** @var string The directory where the element is to be installed */
	var $i_elementdir = '';
	/** @var string The name of the Mambo element */
	var $i_elementname = '';
	/** @var string The name of a special atttibute in a tag */
	var $i_elementspecial = '';
	/** @var object A DOMIT XML document */
	var $i_xmldoc			= null;

	var $i_hasinstallfile = null;
	var $i_installfile = null;

	/**
	* Constructor
	*/
	function cbInstaller() {
		$this->i_iswin = (substr(PHP_OS, 0, 3) == 'WIN');
	}
	/**
	* Uploads and unpacks a file
	* @param string The uploaded package filename or install directory
	* @param boolean True if the file is an archive file
	* @return boolean True on success, False on error
	*/
	function upload($p_filename = null, $p_unpack = true) {
		$this->i_iswin = (substr(PHP_OS, 0, 3) == 'WIN');
		$this->installArchive( $p_filename );

		if ($p_unpack) {
			if ($this->extractArchive()) {
				return $this->findInstallFile();
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	/**
	* Extracts the package archive file
	* @return boolean True on success, False on error
	*/
	function extractArchive() {
		global $mainframe;

		$base_Dir = mosPathName( $mainframe->getCfg('absolute_path') . '/media' );

		$archivename = $base_Dir . $this->installArchive();
		$tmpdir = uniqid( 'install_' );

		$extractdir = mosPathName( $base_Dir . $tmpdir );
		$archivename = mosPathName( $archivename, false );

		$this->unpackDir( $extractdir );

		if (eregi( '.zip$', $archivename )) {
			// Extract functions
			if (file_exists($mainframe->getCfg('absolute_path') . '/libraries/pcl/pclzip.php')) {
				require_once( $mainframe->getCfg('absolute_path') . '/libraries/pcl/pclzip.php' );
				require_once( $mainframe->getCfg('absolute_path') . '/libraries/pcl/pclerror.php' );
			} elseif (file_exists($mainframe->getCfg('absolute_path') . '/administrator/includes/pcl/pclzip.lib.php')) {
				require_once( $mainframe->getCfg('absolute_path') . '/administrator/includes/pcl/pclzip.lib.php' );
				require_once( $mainframe->getCfg('absolute_path') . '/administrator/includes/pcl/pclerror.lib.php' );
			} else {
				$this->setError( 1, 'Unrecoverable error: Zip library missing: "'.$mainframe->getCfg('absolute_path') . '/administrator/includes/pcl/pclzip.lib.php'.'"' );
				return false;
			}
			$zipfile = new PclZip( $archivename );
			if($this->isWindows()) {
				define('OS_WINDOWS',1);
			} else {
				define('OS_WINDOWS',0);
			}

			$ret = $zipfile->extract( PCLZIP_OPT_PATH, $extractdir );
			if($ret == 0) {
				$this->setError( 1, 'Unrecoverable error "'.$zipfile->errorName(true).'"' );
				return false;
			}
		} else {
			require_once( $mainframe->getCfg('absolute_path') . '/includes/Archive/Tar.php' );
			$archive =& new Archive_Tar( $archivename );
			$archive->setErrorHandling( PEAR_ERROR_PRINT );

			if (!$archive->extractModify( $extractdir, '' )) {
				$this->setError( 1, 'Extract Error' );
				return false;
			}
		}

		$this->installDir( $extractdir );

		// Try to find the correct install dir. in case that the package have subdirs
		// Save the install dir for later cleanup
		$filesindir = mosReadDirectory( $this->installDir(), '' );

		if (count( $filesindir ) == 1) {
			if (is_dir( $extractdir . $filesindir[0] )) {
				$this->installDir( mosPathName( $extractdir . $filesindir[0] ) );
			}
		}
		return true;
	}
	/**
	* Tries to find the package XML file
	* @return boolean True on success, False on error
	*/
	function findInstallFile() {
		$found = false;
		// Search the install dir for an xml file
		$files = mosReadDirectory( $this->installDir(), '.xml$', true, false );

		if (count( $files ) > 0) {
			foreach ($files as $file) {
				$packagefile = $this->isPackageFile( $this->installDir() . $file );
				if (!is_null( $packagefile ) && !$found ) {
					$this->xmlDoc( $packagefile );
					return true;
				}
			}
			$this->setError( 1, 'ERROR: Could not find a CB XML setup file in the package.' );
			return false;
		} else {
			$this->setError( 1, 'ERROR: Could not find an XML setup file in the package.' );
			return false;
		}
	}
	/**
	* @param string A file path
	* @return object A DOMIT XML document, or null if the file failed to parse
	*/
	function isPackageFile( $p_file ) {
		$xmlDoc =& new DOMIT_Lite_Document();
		$xmlDoc->resolveErrors( true );

		if (!$xmlDoc->loadXML( $p_file, false, true )) {
			return null;
		}
		$element = &$xmlDoc->documentElement;

		if ($element->getTagName() != 'cbinstall') {
			//echo "didn't find cbinstall";
			return null;
		}
		// Set the type
		//echo "<br />element->getAttribute( 'type' )=".$element->getAttribute( 'type' );
		$this->installType( $element->getAttribute( 'type' ) );
		$this->installFilename( $p_file );
		return $xmlDoc;
	}
	/**
	* Loads and parses the XML setup file
	* @return boolean True on success, False on error
	*/
	function readInstallFile() {

		if ($this->installFilename() == "") {
			$this->setError( 1, 'No filename specified' );
			return false;
		}

		$this->i_xmldoc =& new DOMIT_Lite_Document();
		$this->i_xmldoc->resolveErrors( true );
		if (!$this->i_xmldoc->loadXML( $this->installFilename(), false, true )) {
			return false;
		}
		$main_element = &$this->i_xmldoc->documentElement;

		// Check that it's am installation file
		if ($main_element->getTagName() != 'cbinstall') {
			$this->setError( 1, 'File :"' . $this->installFilename() . '" is not a valid Joomla installation file' );
			return false;
		}
		//echo "<br />main_element->getAttribute( 'type' )=".$main_element->getAttribute( 'type' );
		$this->installType( $main_element->getAttribute( 'type' ) );
		return true;
	}
	/**
	* Abstract install method
	*/
	function install() {
		die( 'Method "install" cannot be called by class ' . strtolower(get_class( $this )) );
	}
	/**
	* Abstract uninstall method
	*/
	function uninstall() {
		die( 'Method "uninstall" cannot be called by class ' . strtolower(get_class( $this )) );
	}
	/**
	* return to method
	*/
	function returnTo( $option, $task ) {
		return "index2.php?option=$option&task=$task";
	}
	/**
	* @param string Install from directory
	* @param string The install type
	* @return boolean
	*/
	function preInstallCheck( $p_fromdir, $type='plugin' ) {

		if (!is_null($p_fromdir)) {
			$this->installDir($p_fromdir);
		}

		if (!$this->installfile()) {
			$this->findInstallFile();
		}

		if (!$this->readInstallFile()) {
			$this->setError( 1, 'Installation file not found:<br />' . $this->installDir() );
			return false;
		}
		
		//echo "<br />type=".$type." this->installType()=".$this->installType();
		if (trim($this->installType()) != trim($type)) {
			//echo "<br />failing here<br />";
			$this->setError( 1, 'XML setup file is not for a "'.$type.'".' );
			return false;
		}
		

		// In case there where an error doring reading or extracting the archive
		if ($this->errno()) {
			return false;
		}

		return true;
	}
	/**
	* @param string The tag name to parse
	* @param string An attribute to search for in a filename element
	* @param string The value of the 'special' element if found
	* @param boolean True for Administrator components
	* @return mixed Number of file or False on error
	*/
	function parseFiles( $tagName='files', $special='', $specialError='', $adminFiles=0 ) {
		global $mainframe;
		// Find files to copy
		$xml =& $this->xmlDoc();

		$files_element =& $xml->getElementsByPath( $tagName, 1 );
		if (is_null( $files_element )) {
			return 0;
		}

		if (!$files_element->hasChildNodes()) {
			// no files
			return 0;
		}
		$files = $files_element->childNodes;
		$copyfiles = array();
		if (count( $files ) == 0) {
			// nothing more to do
			return 0;
		}

		if ($folder = $files_element->getAttribute( 'folder' )) {
			$temp = mosPathName( $this->unpackDir() . $folder );
			if ($temp == $this->installDir()) {
				// this must be only an admin component
				$installFrom = $this->installDir();
			} else {
				$installFrom = mosPathName( $this->installDir() . $folder );
			}
		} else {
			$installFrom = $this->installDir();
		}

		foreach ($files as $file) {
			if (basename( $file->getText() ) != $file->getText()) {
				$newdir = dirname( $file->getText() );

				if ($adminFiles){
					if (!$this->mosMakePath( $this->componentAdminDir(), $newdir )) {
						$this->setError( 1, 'Failed to create directory "' . ($this->componentAdminDir()) . $newdir . '"' );
						return false;
					}
				} else {
					if (!$this->mosMakePath( $this->elementDir(), $newdir )) {
						$this->setError( 1, 'Failed to create directory "' . ($this->elementDir()) . $newdir . '"' );
						return false;
					}
				}
			}
			$copyfiles[] = $file->getText();

			// check special for attribute
			if ($file->getAttribute( $special )) {
				$this->elementSpecial( $file->getAttribute( $special ) );
			}
		}

		if ($specialError) {
			if ($this->elementSpecial() == '') {
				$this->setError( 1, $specialError );
				return false;
			}
		}

		if ($tagName == 'media') {
			// media is a special tag
			$installTo = mosPathName( $mainframe->getCfg('absolute_path') . '/images/stories' );
		} else if ($adminFiles) {
			$installTo = $this->componentAdminDir();
		} else {
			$installTo = $this->elementDir();
		}
		$result = $this->copyFiles( $installFrom, $installTo, $copyfiles );

		return $result;
	}
	/**
	* @param string Source directory
	* @param string Destination directory
	* @param array array with filenames
	* @param boolean True is existing files can be replaced
	* @return boolean True on success, False on error
	*/
	function copyFiles( $p_sourcedir, $p_destdir, $p_files, $overwrite=false ) {
		if (is_array( $p_files ) && count( $p_files ) > 0) {
			foreach($p_files as $_file) {
				$filesource	= mosPathName( mosPathName( $p_sourcedir ) . $_file, false );
				$filedest	= mosPathName( mosPathName( $p_destdir ) . $_file, false );

				if (!file_exists( $filesource )) {
					$this->setError( 1, "File $filesource does not exist!" );
					return false;
				} else if (file_exists( $filedest ) && !$overwrite) {
					$this->setError( 1, "There is already a file called $filedest - Are you trying to install the same Plugin twice?" );
					return false;
				} else if ( (is_callable(array("JFile","copy")) ? !(JFile::copy($filesource, $filedest)) : !(copy($filesource,$filedest))) ) {
					$this->setError( 1, "Failed to copy file: $filesource to $filedest" );
					return false;
				} else if (!((!is_callable("mosChmod")) || is_callable(array("JFile","copy")) || mosChmod( $filedest ))) {		// mambo 4.5.1 support
					$this->setError( 1, "Failed to chmod file: $filedest" );
					return false;
				}
			}
		} else {
			return false;
		}
		return count( $p_files );
	}
	/**
	* Copies the XML setup file to the element Admin directory
	* Used by Plugin/Components/Modules/Mambot Installer Installer
	* @return boolean True on success, False on error
	*/
	function copySetupFile( $where='admin' ) {
		if ($where == 'admin') {
			return $this->copyFiles( $this->installDir(), $this->componentAdminDir(), array( basename( $this->installFilename() ) ), true );
		} else if ($where == 'front') {
			return $this->copyFiles( $this->installDir(), $this->elementDir(), array( basename( $this->installFilename() ) ), true );
		}
		return false;
	}

	/**
	* @param int The error number
	* @param string The error message
	*/
	function setError( $p_errno, $p_error ) {
		$this->errno( $p_errno );
		$this->error( $p_error );
	}
	/**
	* @param boolean True to display both number and message
	* @param string The error message
	* @return string
	*/
	function getError($p_full = false) {
		if ($p_full) {
			return $this->errno() . " " . $this->error();
		} else {
			return $this->error();
		}
	}
	/**
	* @param string The name of the property to set/get
	* @param mixed The value of the property to set
	* @return The value of the property
	*/
	function setVar( $name, $value=null ) {
		if (!is_null( $value )) {
			$this->$name = $value;
		}
		return $this->$name;
	}

	function installFilename( $p_filename = null ) {
		if(!is_null($p_filename)) {
			if($this->isWindows()) {
				$this->i_installfilename = str_replace('/','\\',$p_filename);
			} else {
				$this->i_installfilename = str_replace('\\','/',$p_filename);
			}
		}
		return $this->i_installfilename;
	}

	function installType( $p_installtype = null ) {
		return $this->setVar( 'i_installtype', $p_installtype );
	}

	function error( $p_error = null ) {
		return $this->setVar( 'i_error', $p_error );
	}

	function xmlDoc( $p_xmldoc = null ) {
		return $this->setVar( 'i_xmldoc', $p_xmldoc );
	}

	function installArchive( $p_filename = null ) {
		return $this->setVar( 'i_installarchive', $p_filename );
	}

	function installDir( $p_dirname = null ) {
		return $this->setVar( 'i_installdir', $p_dirname );
	}

	function unpackDir( $p_dirname = null ) {
		return $this->setVar( 'i_unpackdir', $p_dirname );
	}

	function isWindows() {
		return $this->i_iswin;
	}

	function errno( $p_errno = null ) {
		return $this->setVar( 'i_errno', $p_errno );
	}

	function hasInstallfile( $p_hasinstallfile = null ) {
		return $this->setVar( 'i_hasinstallfile', $p_hasinstallfile );
	}

	function installfile( $p_installfile = null ) {
		return $this->setVar( 'i_installfile', $p_installfile );
	}

	function elementDir( $p_dirname = null )	{
		return $this->setVar( 'i_elementdir', $p_dirname );
	}

	function elementName( $p_name = null )	{
		return $this->setVar( 'i_elementname', $p_name );
	}
	function elementSpecial( $p_name = null )	{
		return $this->setVar( 'i_elementspecial', $p_name );
	}
	/**
* @param string An existing base path
* @param string A path to create from the base path
* @param int Directory permissions
* @return boolean True if successful
*/
	function mosMakePath($base, $path='', $mode = NULL)
	{
		global $mosConfig_dirperms;

		if (is_callable("mosMakePath"))	return mosMakePath($base, $path, $mode);
		else {									
			// mambo 4.5.1 compatibility:
			// convert windows paths
			$path = str_replace( '\\', '/', $path );
			$path = str_replace( '//', '/', $path );

			// check if dir exists
			if (file_exists( $base . $path )) return true;

			// set mode
			$origmask = NULL;
			if (isset($mode)) {
				$origmask = @umask(0);
			} else {
				if ($mosConfig_dirperms=='') {
					// rely on umask
					$mode = 0777;
				} else {
					$origmask = @umask(0);
					$mode = octdec($mosConfig_dirperms);
				} // if
			} // if

			$parts = explode( '/', $path );
			$n = count( $parts );
			$ret = true;
			if ($n < 1) {
				$ret = @mkdir($base, $mode);
			} else {
				$path = $base;
				for ($i = 0; $i < $n; $i++) {
					$path .= $parts[$i] . '/';
					if (!file_exists( $path )) {
						if (!@mkdir( $path, $mode )) {
							$ret = false;
							break;
						}
					}
				}
			}
			if (isset($origmask)) @umask($origmask);
			return $ret;
		}
	}
}	// end class cbInstaller

function cleanupInstall( $userfile_name, $resultdir) {
	global $mainframe;

	if (file_exists( $resultdir )) {
		deldir( $resultdir );
		unlink( mosPathName( $mainframe->getCfg('absolute_path') . '/media/' . $userfile_name, false ) );
	}
}

function deldir( $dir ) {
	$current_dir = opendir( $dir );
	while ($entryname = readdir( $current_dir )) {
		if ($entryname != '.' and $entryname != '..') {
			if (is_dir( $dir . $entryname )) {
				deldir( mosPathName( $dir . $entryname ) );
			} else {
				unlink( $dir . $entryname );
			}
		}
	}
	closedir( $current_dir );
	return rmdir( $dir );
}
class cbInstallerPlugin extends cbInstaller {
	/** @var string The element type */
	var $elementType = 'plugin';

	/**
	* Constructor
	*/
	function cbInstallerPlugin() {
		$this->cbInstaller();
	}

	/**
	* Custom install method
	* @param boolean True if installing from directory
	*/
	function install( $p_fromdir = null ) {
		global $mainframe, $database, $ueConfig;
        
		if (!$this->preInstallCheck( $p_fromdir,$this->elementType )) {
			return false;
		}

		$xml = $this->xmlDoc();
		$mosinstall =& $xml->documentElement;

		// Get name
		$e = &$xml->getElementsByPath( 'name', 1 );
		$this->elementName( $e->getText() );
		$cleanedElementName = strtolower(str_replace(array(" ","."),array("","_"),$this->elementName()));

		// Get plugin filename
		$files_element = &$xml->getElementsByPath( 'files', 1 );
		if ($files_element->hasChildNodes()) {
			$files = $files_element->childNodes;
			foreach ($files as $file) {
				if ($file->getAttribute( "plugin" )) {
					$this->elementSpecial( $file->getAttribute( "plugin" ) );
				}
			}
		}
		$fileNopathNoext = null;
		$eregmatches = array();
		if ( ereg("^.*[\/\\](.*)\..*$", $this->installFilename(), $eregmatches ) ) {
			$fileNopathNoext = $eregmatches[1];
		}
		if ( ! ( $fileNopathNoext && ( $this->elementSpecial() == $fileNopathNoext ) ) ) {
			$this->setError( 1, 'Installation filename `' . $fileNopathNoext . '` (with .xml) does not match main php file plugin attribute `'  . $this->elementSpecial() . '` in the plugin xml file<br />' );
			return false;
		}
		$cleanedMainFileName = strtolower(str_replace(array(" ","."),array("","_"),$this->elementSpecial()));

		// check version
		$v = &$xml->getElementsByPath( 'version', 1 );
		$version = $v->getText();
		if (($version == $ueConfig['version']) || ($version=="1.0 RC 2" || $version=="1.0" || $version=="1.0.1")) {
			;
		} else {
      		$this->setError( 1, 'Plugin version ('.$version.') different from Community Builder version ('.$ueConfig['version'].')' );
			return false;
    	}

		$folder = strtolower($mosinstall->getAttribute( 'group' ));
		$subFolderPrefix = (($folder=="user") ? "plug_" : "");
		$subFolder = $subFolderPrefix . $cleanedElementName;
		$this->elementDir( $mainframe->getCfg('absolute_path') . '/components/com_comprofiler/plugin/' . $folder . "/" . $subFolder . "/" );
		
		if (file_exists($this->elementDir())) {
      		$this->setError( 1, 'Another plugin is already using directory: "' . $this->elementDir() . '"' );
			return false;
    	}

		if(!file_exists($this->elementDir()) && !$this->mosMakePath($this->elementDir())) {
			$this->setError( 1, 'Failed to create directory' .' "' . $this->elementDir() . '"' );
			return false;
		}

		if ($this->parseFiles( 'files', 'plugin', 'No file is marked as plugin file' ) === false) {
			@rmdir($this->elementDir());	// try removing directory just created successfully
			return false;
		}

		// Check to see if plugin already exists in db
		$database->setQuery( "SELECT id FROM #__comprofiler_plugin WHERE element = '" . $this->elementSpecial() . "' AND folder = '" . $subFolder . "'" );
		if (!$database->query()) {
			$this->setError( 1, 'SQL error' .': ' . $database->stderr( true ) );
			@rmdir($this->elementDir());	// try removing directory just created successfully
			return false;
		}

		$pluginid = $database->loadResult();

		$row = new moscomprofilerPlugin( $database );
		$row->id = $pluginid;
		if (!$pluginid) {
			$row->name = $this->elementName();
			$row->ordering = 99;
		}
		$row->type = $folder;
		$row->folder = $subFolder;
		$row->iscore = 0;
		$row->access = 0;
		$row->client_id = 0;
		$row->element = $this->elementSpecial();

		if (!$row->store()) {
			$this->setError( 1, 'SQL error' .': ' . $row->getError() );
			@rmdir($this->elementDir());	// try removing directory just created successfully
			return false;
		}
		if (!$pluginid) $pluginid=$database->insertid();
			
		if ($e = &$xml->getElementsByPath( 'description', 1 )) {
			$desc = $this->elementName() . '<p>' . $e->getText() . '</p>';
			$this->setError( 0, $desc );
		}
		//If type equals user then check for tabs and fields
		if($folder=='user') {
			$tabsnode=&$xml->getElementsByPath('tabs',1);
			if(!is_null($tabsnode)) {
				//get set of tabs
				$tabs=$tabsnode->childNodes;
				//cycle through each tab
				foreach($tabs AS $tab) {
					if ($tab->getTagName() == "tab") {
						//install each tab
						$tabid=$this->installTab($pluginid,$tab);
						//get all fields in the tab
						if($fieldsnode=$tab->getElementsByPath('fields',1)) {
							//echo $fieldsnode->toNormalizedString(true);
							if(!is_null($fieldsnode)) {
								//echo "found fields";
								$fields=$fieldsnode->childNodes;
								//cycle through each field
								foreach($fields AS $field) {
									if ($field->getTagName() == "field") {
										//install each field
										//echo "installing field...";
										$fieldid=$this->installField($pluginid,$tabid,$field);
										//get all fieldvalues for the field
										$fieldValues=$field->childNodes;
										//check to see if the node exists
										if(!is_null($fieldValues)) {
											//cycle through each fieldValue
											foreach($fieldValues AS $fieldValue) {	
												if ($fieldValue->getTagName() == "fieldvalue") $this->installFieldValue($fieldid,$fieldValue);
													
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
		// Are there any SQL queries??
		$query_element = &$xml->getElementsByPath('install/queries', 1);
		if (!is_null($query_element)) {
			$queries = $query_element->childNodes;
			foreach($queries as $query)
			{
				$database->setQuery( $query->getText());
				if (!$database->query())
				{
					$this->setError( 1, "SQL Error " . $database->stderr( true ) );
					return false;
				}
			}
		}
		
		// Is there an installfile
		$installfile_elemet = &$mosinstall->getElementsByPath('installfile', 1);

		if (!is_null($installfile_elemet)) {
			// check if parse files has already copied the install.component.php file (error in 3rd party xml's!)
			if (!file_exists($this->elementDir().$installfile_elemet->getText())) {
				if(!$this->copyFiles($this->installDir(), $this->elementDir(), array($installfile_elemet->getText())))  			{
					$this->setError( 1, 'Could not copy PHP install file.' );
					return false;
				}
			}
			$this->hasInstallfile(true);
			$this->installFile($installfile_elemet->getText());
		}
		// Is there an uninstallfile
		$uninstallfile_elemet = &$mosinstall->getElementsByPath('uninstallfile',1);
		if(!is_null($uninstallfile_elemet)) {
			if (!file_exists($this->elementDir().$uninstallfile_elemet->getText())) {
				if(!$this->copyFiles($this->installDir(), $this->elementDir(), array($uninstallfile_elemet->getText()))) {
					$this->setError( 1, 'Could not copy PHP uninstall file' );
					return false;
				}
			}
		}
		
		if ($this->hasInstallfile()) {
			if (is_file($this->elementDir() . '/' . $this->installFile())) {
				global $_PLUGINS;
				require_once($this->elementDir() . "/" . $this->installFile());
				$ret = call_user_func_array("plug_".$cleanedMainFileName."_install", array());
				if ($ret != '') {
					$this->setError( 0, $desc . $ret );
				}
			}
		}
		
		$this->copySetupFile('front');
		return true;
	}
	
	
	/**
	* @param string The tag name to parse
	* @param string An attribute to search for in a filename element
	* @param string The value of the 'special' element if found
	* @param boolean True for Administrator components
	* @return mixed Number of file or False on error
	*/
	function installTab( $pluginid,$tab) {
		global $database;

		// Check to see if plugin tab already exists in db
		$database->setQuery( "SELECT tabid FROM #__comprofiler_tabs WHERE pluginid = " . (int) $pluginid . " AND pluginclass = '" . $tab->getAttribute('class') . "'" );
		$tabid = $database->loadResult();
		
		$row = new moscomprofilerTabs( $database );
		if (!$tabid) {
			$row->title = $tab->getAttribute('name');
			$row->description = $tab->getAttribute('description');
			$row->ordering=99;
			$row->position = $tab->getAttribute('position');
			$row->displaytype = $tab->getAttribute('displaytype');
		}
		$row->width = $tab->getAttribute('width');
		$row->pluginclass = $tab->getAttribute('class');
		$row->pluginid = $pluginid;
		$row->fields = $tab->getAttribute('fields');
		$row->sys = $tab->getAttribute('sys');

		if (!$row->store($tabid)) {
			$this->setError( 1, 'SQL error' .': ' . $row->getError() );
			return false;
		}

		if (!$tabid) $tabid = $database->insertid();
		return $tabid;
	}
	
	/**
	* @param string The tag name to parse
	* @param string An attribute to search for in a filename element
	* @param string The value of the 'special' element if found
	* @param boolean True for Administrator components
	* @return mixed Number of file or False on error
	*/
	function installField( $pluginid,$tabid,$field) {
		global $database;

		// Check to see if plugin tab already exists in db
		$database->setQuery( "SELECT fieldid FROM #__comprofiler_fields WHERE name = '".$field->getAttribute('name')."'" );
		$fieldid = $database->loadResult();

		$row = new moscomprofilerFields( $database );
		$row->name = $field->getAttribute('name');
		$row->pluginid = $pluginid;
		if (!$fieldid) {
			$row->title = $field->getAttribute('title');
			$row->description = $field->getAttribute('description');
			$row->ordering=99;
			$row->tabid = $tabid;
			$row->type = $field->getAttribute('type');
			$row->registration = $field->getAttribute('registration');
			$row->profile = $field->getAttribute('profile');
			$row->readonly = $field->getAttribute('readonly');
			$row->params = $field->getAttribute('params');
		}

		if (!$row->store($fieldid)) {
			$this->setError( 1, 'SQL error on field store2' .': ' . $row->getError() );
			return false;
		}
		
		if (!$fieldid) $fieldid = $database->insertid();
		return $fieldid;
	}
	
	function installFieldValue($fieldid,$fieldvalue) {
		global $database;		
		$row = new moscomprofilerFieldValues($database);
		$row->fieldid = $fieldid;
		$row->fieldtitle = $fieldvalue->getAttribute('title');
		$row->ordering = $fieldvalue->getAttribute('ordering');
		$row->sys = $fieldvalue->getAttribute('sys');
		
		$database->setQuery("SELECT fieldvalueid FROM #__comprofiler_field_values WHERE fieldid = ". (int) $fieldid . " AND fieldtitle = '".$row->fieldtitle."'");
		$fieldvalueid = $database->loadResult();
		
		if (!$row->store($fieldvalueid)) {
			$this->setError( 1, 'SQL error on field store' .': ' . $row->getError() );
			return false;
		}
		
		return true;
	}
	
	/**
	* Custom install method
	* @param int The id of the module
	* @param string The URL option
	* @param int The client id
	*/
	function uninstall( $id, $option, $client=0 ) {
		global $database, $mainframe;

		$id = intval( $id );
		$database->setQuery( "SELECT `name`, `folder`, `element`, `type`, `iscore` FROM #__comprofiler_plugin WHERE `id` = " . (int) $id );

		$row = null;
		$database->loadObject( $row );
		if ($database->getErrorNum()) {
			HTML_comprofiler::showInstallMessage( $database->stderr(), 'Uninstall -  error' ,
			$this->returnTo( $option, 'showPlugins') );
			exit();
		}
		if ($row == null) {
			HTML_comprofiler::showInstallMessage( 'Invalid object id', 'Uninstall -  error' ,
			$this->returnTo( $option, 'showPlugins') );
			exit();
		}

		if (trim( $row->folder ) == '') {
			HTML_comprofiler::showInstallMessage( 'Folder field empty, cannot remove files', 'Uninstall -  error',
			$this->returnTo( $option, 'showPlugins') );
			exit();
		}
		
		if ($row->iscore) {
			HTML_comprofiler::showInstallMessage( $row->name .' '. "is a core element, and cannot be uninstalled.<br />You need to unpublish it if you don\'t want to use it" ,
			'Uninstall -  error', $this->returnTo( $option, 'showPlugins') );
			exit();
		}

		$basepath = $mainframe->getCfg('absolute_path') . '/components/com_comprofiler/plugin/' . $row->type . '/'.$row->folder.'/';
		$xmlfile = $basepath . $row->element . '.xml';

		// see if there is an xml install file, must be same name as element
		if (file_exists( $xmlfile )) {
			$this->i_xmldoc =& new DOMIT_Lite_Document();
			$this->i_xmldoc->resolveErrors( true );

			if ($this->i_xmldoc->loadXML( $xmlfile, false, true )) {
				$mosinstall =& $this->i_xmldoc->documentElement;
				
				// get the element name:
				$e =& $mosinstall->getElementsByPath( 'name', 1 );
				$this->elementName( $e->getText() );
				$cleanedElementName = strtolower(str_replace(array(" ","."),array("","_"),$this->elementName()));
				
				// get the files element
				$files_element =& $mosinstall->getElementsByPath( 'files', 1 );
				if (!is_null( $files_element )) {

					if ($files_element->hasChildNodes()) {
						$files = $files_element->childNodes;
						foreach ($files as $file) {
							if ($file->getAttribute( "plugin" )) {
								$this->elementSpecial( $file->getAttribute( "plugin" ) );
							}
						}
						$cleanedMainFileName = strtolower(str_replace(array(" ","."),array("","_"),$this->elementSpecial()));
					}

					// Is there an uninstallfile
					$uninstallfile_elemet = &$mosinstall->getElementsByPath( 'uninstallfile' , 1 );
					if (!is_null($uninstallfile_elemet)) {
						if (is_file($basepath . $uninstallfile_elemet->getText())) {
							global $_PLUGINS;
							require_once($basepath . $uninstallfile_elemet->getText());
							$ret = call_user_func_array("plug_".$cleanedMainFileName."_uninstall", array());

							if ($ret != '') {
								$this->setError( 0, $ret );
							}
						}
					}

					
					$files = $files_element->childNodes;
					foreach ($files as $file) {
						// delete the files
						$filename = $file->getText();
						if (file_exists( $basepath . $filename )) {
							$parts = pathinfo( $filename );
							$subpath = $parts['dirname'];
							if ($subpath <> '' && $subpath <> '.' && $subpath <> '..') {
								//echo '<br />'. 'Deleting'  .': '. $basepath . $subpath;
								if (is_callable(array("JFolder","delete"))) {
									$result = JFolder::delete(mosPathName( $basepath . $subpath . '/' ));
								} else {
									$result = deldir(mosPathName( $basepath . $subpath . '/' ));
								}
							} else {
								//echo '<br />'. 'Deleting'  .': '. $basepath . $filename;
								if (is_callable(array("JFile","delete"))) {
									$result = JFile::delete( mosPathName ($basepath . $filename, false));
								} else {
									$result = unlink( mosPathName ($basepath . $filename, false));
								}
							}
							//echo intval( $result );
						}
					}
					
					// Are there any SQL queries??
					$query_element = &$mosinstall->getElementsByPath('uninstall/queries', 1);
					if (!is_null($query_element)) {
						$queries = $query_element->childNodes;
						foreach($queries as $query)
						{
							$database->setQuery( $query->getText());
							if (!$database->query())
							{
								$this->setError( 1, "SQL Error " . $database->stderr( true ) );
								return false;
							}
						}
					}
					//Find all tabs related to this plugin
					$database->setQuery("SELECT `tabid`,`fields` FROM #__comprofiler_tabs WHERE pluginid=". (int) $id);
					$tabs=$database->loadObjectList();
					if(count($tabs)>0) {
						$rowTab=new moscomprofilerTabs($database);
						foreach($tabs AS $tab) {
							//Find all fields related to the tab
							$database->setQuery("SELECT `fieldid`,`name` FROM #__comprofiler_fields WHERE `tabid`=" . (int) $tab->tabid . " AND `pluginid`=" . (int) $id);
							$fields=$database->loadObjectList();
							$rowField=new moscomprofilerFields($database);
							
							//Delete fields and fieldValues, but not data content itself in the comprofilier table so they stay on reinstall
							if(count($fields)>0) {
								//delete each field related to a tab and all field value related to a field, but not the content
								foreach($fields AS $field) {
									//Now delete the field itself without deleting the user data, preserving it for reinstall
									//$rowField->deleteColumn('#__comprofiler',$field->name);	// this would delete the user data
									$rowField->delete($field->fieldid);
								}
							}
							$fcount=0;
							if($tab->fields) {
								$database->setQuery("SELECT COUNT(*) FROM #__comprofiler_fields WHERE tabid=" . (int) $tab->tabid);
								$fcount=$database->loadResult();
								if($fcount>0) {
									$database->setQuery("UPDATE #__comprofiler_tabs SET `pluginclass`=null, `pluginid`=null WHERE `tabid`=" . (int) $tab->tabid);
									$database->query();
								} else {
									//delete each tab
									$rowTab->delete($tab->tabid);
								}
							} else {
								//delete each tab
								$rowTab->delete($tab->tabid);
							}
						}	
					}
					// remove XML file from front
		          //echo 'Deleting XML File' .": ". $xmlfile;
					if (is_callable(array("JFile","delete"))) {
						$result = JFile::delete(mosPathName ($xmlfile, false ));
					} else {
						@unlink(  mosPathName ($xmlfile, false ) );
					}

					// define folders that should not be removed
					$sysFolders = array(
					'content',
					'search'
					);
					if (!in_array( $row->folder, $sysFolders )) {
						// delete the non-system folders if empty
						if (count( mosReadDirectory( $basepath ) ) < 1) {
							if (is_callable(array("JFolder","delete"))) {
								$result = JFolder::delete( $basepath );
							} else {
								deldir( $basepath );
							}
						}
					}
				}
			}
		}



		$database->setQuery( "DELETE FROM #__comprofiler_plugin WHERE id = " . (int) $id );
		if (!$database->query()) {
			$msg = $database->stderr;
			die( $msg );
		}
		return true;
	}

}



/**
* Parameters handler
* @package Joomla Community Builder
*/
class cbParameters {
	/** @var object */
	var $_params = null;
	/** @var string The raw params string */
	var $_raw = null;
	/** @var string Path to the xml setup file */
	var $_path = null;
	/** @var string The main enclosing tag name */
	var $_maintagname = null;
	/** @var string The attribute name of setup file */
	var $_attrname = null;
	/** @var string The attribute value of setup file */
	var $_attrvalue = null;
	/** @var string The attribute value of setup file */
	var $_paramsnode = null;
	/** @var object The xml params element */
	var $_xmlElem = null;
/**
* Constructor
* @param string The raw parms text
* @param string Path to the xml setup file
* @param string The type of setup file
*/
	function cbParameters( $text, $path='', $maintagname='cbinstall', $attrname='type', $attrvalue='plugin', $paramsnode='params' ) {
	    $this->_params = $this->parse( $text );
	    $this->_raw = $text;
	    $this->_path = $path;
	    $this->_maintagname = $maintagname;
	    $this->_attrname = $attrname;
	    $this->_attrvalue = $attrvalue;
	    $this->_paramsnode = $paramsnode;
	}
/**
* Converts the parameters received as POST array into the raw parms text
* @param mixed POST array or string
* @return string The raw parms text
* @var string The type of setup file
*/
	function getRawParams ( $params ) {
		$ret = null;
		if(is_array($params)) {
			foreach ($params as $k=>$v) {
		   	  if (is_array($v)) $v = implode("|*|", $v);
		        if (get_magic_quotes_gpc()) {
		            $v = stripslashes( $v );
		    	}
		      	$txt[] = "$k=$v";
		    }
		 	$ret = cbParameters::textareaHandling( $txt );
		} else {
			$ret = $params;
		}
		return $ret;
	}
/**
* @param string The name of the param
* @param string The value of the parameter
* @return string The set value
*/
	function set( $key, $value='' ) {
		$this->_params->$key = $value;
		return $value;
	}
/**
* Sets a default value if not alreay assigned
* @param string The name of the param
* @param string The value of the parameter
* @return string The set value
*/
	function def( $key, $value='' ) {
	    return $this->set( $key, $this->get( $key, $value ) );
	}
/**
* @param string The name of the param
* @param mixed The default value if not found
* @return string
*/
	function get( $key, $default=null ) {
	    if (isset( $this->_params->$key )) {
	        return $this->_params->$key === null ? $default : $this->_params->$key;
		} else {
		    return $default;
		}
	}
/**
* Parse an .ini string, based on phpDocumentor phpDocumentor_parse_ini_file function
* @param mixed The ini string or array of lines
* @param boolean add an associative index for each section [in brackets]
* @return object
*/
	function parse( $txt, $process_sections = false ) {
	    if (is_string( $txt )) {
			$lines = explode( "\n", $txt );
		} else if (is_array( $txt )) {
		    $lines = $txt;
		} else {
		    $lines = array();
		}
		$obj = new stdClass();

	    $sec_name = '';
	    $unparsed = 0;
	    if (!$lines) {
			return $obj;
		}
	    foreach ($lines as $line) {
	        // ignore comments
	        if ($line && $line[0] == ';') {
				continue;
			}
	        $line = trim( $line );

	        if ($line == '') {
	            continue;
	        }
	        if ($line && $line[0] == '[' && $line[strlen($line) - 1] == ']') {
	            $sec_name = substr( $line, 1, strlen($line) - 2 );
				if ($process_sections) {
	            	$obj->$sec_name = new stdClass();
	            }
	        } else {
	            if ($pos = strpos( $line, '=' )) {
	                $property = trim( substr( $line, 0, $pos ) );

	                if (substr($property, 0, 1) == '"' && substr($property, -1) == '"') {
	            		$property = stripcslashes(substr($property,1,count($property) - 2));
	                }
	                $value = trim( substr( $line, $pos + 1 ) );
	                if ($value == 'false') {
						$value = false;
					}
	                if ($value == 'true') {
						$value = true;
					}
	                if (substr( $value, 0, 1 ) == '"' && substr( $value, -1 ) == '"') {
	                    $value = stripcslashes( substr( $value, 1, count( $value ) - 2 ) );
	                }

	                if ($process_sections) {
	                    if ($sec_name != '') {
      						$obj->$sec_name->$property = $value;
      					} else {
        					$obj->$property = $value;
        				}
	                } else {
						$obj->$property = $value;
	                }
	            } else {
	                if ($line && trim($line[0]) == ';') {
						continue;
					}
	                if ($process_sections) {
	                    $property = '__invalid' . $unparsed++ . '__';
		                if ($process_sections) {
		                    if ($sec_name != '') {
	      						$obj->$sec_name->$property = trim($line);
	      					} else {
	        					$obj->$property = trim($line);
	        				}
		                } else {
							$obj->$property = trim($line);
		                }
	                }
	            }
	        }
	    }
	    return $obj;
	}
/**
* @param string The name of the control, or the default text area if a setup file is not found
* @return string HTML
*/
	function render( $pluginId=null, $tabId=null, $tag_name='params',$attr=null,$attrvalue=null, $control_name='params', $paramstextarea=true ) {
		global $mainframe;
	    if ($this->_path && file_exists($this->_path)) {
	        if (!is_object( $this->_xmlElem )) {
				require_once( $mainframe->getCfg('absolute_path') . '/includes/domit/xml_domit_lite_include.php' );

				$xmlDoc =& new DOMIT_Lite_Document();
				$xmlDoc->resolveErrors( true );
				if ($xmlDoc->loadXML( $this->_path, false, true )) {
					unset($xmlDoc->childNodes[-1]);			// corrects a DOMIT bug in 4.5.2 + J1.0 (reported)
					$element =& $xmlDoc->documentElement;
					if ($element->getTagName() == $this->_maintagname && $element->getAttribute( $this->_attrname ) == $this->_attrvalue) {
						if($attr!=null && $attrvalue!=null) {
							if ($element = &$xmlDoc->getElementsByAttribute( $attr,$attrvalue,true )) {
								$xmlDoc->setDocumentElement($element);
								// echo "XML structure:<br />\n".$xmlDoc->toNormalizedString(true);
								if($element = & $xmlDoc->getElementsByPath( $tag_name, 1 )) {
									$this->_xmlElem =& $element;
								}
							}
						} else {
							if ($element = &$xmlDoc->getElementsByPath( $tag_name, 1 )) {
								$this->_xmlElem =& $element;
							}
						}
					}
				}
			}
		}

	    if (is_object( $this->_xmlElem )) {
			$html = array();
			$html[] = '<table class="paramlist">';

			$element =& $this->_xmlElem;

			if ($description = $element->getAttribute( 'description' )) {
			    // add the params description to the display
			    $html[] = '<tr><td colspan="3">' . getLangDefinition($description) . '</td></tr>';
			}

			//$params = mosParseParams( $row->params );
			$this->_methods = get_class_methods( get_class( $this ) );

			foreach ($element->childNodes as $param) {
				$result = $this->renderParam( $pluginId, $tabId, $param, $control_name );
				$html[] = '<tr>';

				$html[] = '<td width="35%" align="right" valign="top">' . $result[0] . '</td>';
				$html[] = '<td>' . $result[1] . '</td>';
				$html[] = '<td width="10%" align="left" valign="top">' . $result[2] . "</td>";

				$html[] = '</tr>';
			}
			$html[] = '</table>';

			if (count( $element->childNodes ) < 1) {
				$html[] = "<tr><td colspan=\"2\"><i>" . _NO_PARAMS . "</i></td></tr>";
			}
			return implode( "\n", $html );
		} else {
			if ($paramstextarea) {
				return "<textarea name=\"$control_name\" cols=\"40\" rows=\"10\" class=\"text_area\">".htmlspecialchars($this->_raw)."</textarea>";
			} else {
				return null;
			}
		}
	}
/**
* @param object A param tag node
* @param string The control name
* @return array Any array of the label, the form element and the tooltip
*/
	function renderParam( $pluginId, $tabId, &$param, $control_name='params' ) {
	    $result = array();

		$name = getLangDefinition($param->getAttribute( 'name' ));
		$label = getLangDefinition($param->getAttribute( 'label' ));

		$value = $this->get( $name, $param->getAttribute( 'default' ) );
		$description = getLangDefinition(htmlspecialchars($param->getAttribute( 'description' )));

		$result[0] = $label ? $label : $name;
		if ( $result[0] == '@spacer' ) {
			$result[0] = '<hr/>';
		} else if ( $result[0] ) {
			if ($name == '@spacer')	$result[0] = '<strong>'.$result[0].'</strong>';
			else $result[0] .= ':';
		}

		$type = $param->getAttribute( 'type' );

		if (in_array( '_form_' . $type, $this->_methods )) {
			$result[1] = call_user_func( array( &$this, '_form_' . $type ), $name, $value, $param, $control_name, $pluginId, $tabId );
		} else {
		    $result[1] = _HANDLER . ' = ' . $type;
		}

		if ( $description ) {
			if (is_callable("mosToolTip")) {
				$result[2] = mosToolTip( $description, $name );
			} else {
				$result[2] = $description;		// Mambo 4.5.0 compatibility
			}
		} else {
			$result[2] = '';
		}

		return $result;
	}
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_text( $name, $value, &$node, $control_name ) {
		$size = $node->getAttribute( 'size' );

		return '<input type="text" name="'. $control_name .'['. $name .']" value="'. htmlspecialchars($value) .'" class="text_area" size="'. $size .'" />';
	}
	
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_custom( $name, $value, &$node, $control_name, $pluginId, $tabId ) {
		global $database, $_PLUGINS;
		$class = $node->getAttribute( 'class' );
		$method = $node->getAttribute( 'method' );
		if(!is_null($class) && strlen(trim($class)) > 0) {
			if ($pluginId !== null) {
				$params = null;
				if ($tabId !== null) {
					$database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
					. "\n WHERE t.enabled=1 AND t.tabid = " . (int) $tabId);
					$oTabs = $database->loadObjectList();
					echo $oTabs[0]->params;
					if (count($oTabs)>0) $params = $oTabs[0]->params;
				}
				$args = array($name,$value,$control_name);
				$_PLUGINS->plugVarValue($pluginId, "published", "1");		// need to be able to call also unpublished plugin for parametring
				return $_PLUGINS->call($pluginId,$method,$class,$args,$params);
			} else {
				$udc = new $class();
				if(method_exists($udc,$method)) {
					return call_user_func_array(array($udc,$method),array($name,$value,$control_name));
				}
			}		
		} elseif (function_exists( $method )) {
			return call_user_func_array( $method, array($name,$value,$control_name) );
		}
		return "";
			
	}
	
	
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_list( $name, $value, &$node, $control_name ) {
		$size = $node->getAttribute( 'size' );

		$options = array();
		foreach ($node->childNodes as $option) {
			$val = $option->getAttribute( 'value' );
			$text = getLangDefinition($option->gettext());
			$options[] = mosHTML::makeOption( $val, $text );
		}

		return mosHTML::selectList( $options, ''. $control_name .'['. $name .']', 'class="inputbox"', 'value', 'text', $value );
	}
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_radio( $name, $value, &$node, $control_name ) {
		$options = array();
		foreach ($node->childNodes as $option) {
			$val = $option->getAttribute( 'value' );
			$text = getLangDefinition($option->gettext());
			$options[] = mosHTML::makeOption( $val, $text );
		}

		if (is_callable(array("mosHTML","radioList"))) {			// mambo 4.5.0 ....
			return mosHTML::radioList( $options, ''. $control_name .'['. $name .']', '', $value );
		} else {
			return moscomprofilerHTML::radioList( $options, ''. $control_name .'['. $name .']', '', $key='value', $text='text', $value );
		}
	}
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_mos_section( $name, $value, &$node, $control_name ) {
		global $database;

		$query = "SELECT id AS value, title AS text"
		. "\n FROM #__sections"
		. "\n WHERE published = 1 AND scope = 'content'"
		. "\n ORDER BY title"
		;
		$database->setQuery( $query );
		$options = $database->loadObjectList();
		array_unshift( $options, mosHTML::makeOption( '0', '- Select Content Section -' ) );

		return mosHTML::selectList( $options, ''. $control_name .'['. $name .']', 'class="inputbox"', 'value', 'text', $value );
	}
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_mos_category( $name, $value, &$node, $control_name ) {
		global $database;

		$query 	= "SELECT c.id AS value, CONCAT_WS( '/',s.title, c.title ) AS text"
		. "\n FROM #__categories AS c"
		. "\n LEFT JOIN #__sections AS s ON s.id=c.section"
		. "\n WHERE c.published = 1 AND s.scope='content'"
		. "\n ORDER BY c.title"
		;
		$database->setQuery( $query );
		$options = $database->loadObjectList();
		array_unshift( $options, mosHTML::makeOption( '0', '- Select Content Category -' ) );

		return mosHTML::selectList( $options, ''. $control_name .'['. $name .']', 'class="inputbox"', 'value', 'text', $value );
	}
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_field( $name, $value, &$node, $control_name ) {
		global $database;

		$query 	= "SELECT f.fieldid AS value, f.title AS text"
		. "\n FROM #__comprofiler_fields AS f"
		. "\n LEFT JOIN #__comprofiler_tabs AS t ON t.tabid = f.tabid"
		. "\n WHERE f.published = 1 AND f.name != 'NA'"
		. "\n ORDER BY t.ordering, f.ordering"
		;
		$database->setQuery( $query );
		$options = $database->loadObjectList();
		for ($i=0, $n=count($options); $i<$n; $i++) $options[$i]->text = getLangDefinition($options[$i]->text);
		array_unshift( $options, mosHTML::makeOption( '0', '- Select Field -' ) );

		return mosHTML::selectList( $options, ''. $control_name .'['. $name .']', 'class="inputbox"', 'value', 'text', $value );
	}
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_mos_menu( $name, $value, &$node, $control_name ) {
		global $database;

		$menuTypes = mosAdminMenus::menutypes();
		
		foreach($menuTypes as $menutype ) {
			$options[] = mosHTML::makeOption( $menutype, $menutype );
		}
		array_unshift( $options, mosHTML::makeOption( '', '- Select Menu -' ) );

		return mosHTML::selectList( $options, ''. $control_name .'['. $name .']', 'class="inputbox"', 'value', 'text', $value );
	}
	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_imagelist( $name, $value, &$node, $control_name ) {
		global $mainframe;

		// path to images directory
		$path = $mainframe->getCfg('absolute_path') . $node->getAttribute( 'directory' );
		$files = mosReadDirectory( $path, '\.png$|\.gif$|\.jpg$|\.bmp$|\.ico$' );

		$options = array();
		foreach ($files as $file) {
			$options[] = mosHTML::makeOption( $file, $file );
		}
		if ( !$node->getAttribute( 'hide_none' ) ) {
			array_unshift( $options, mosHTML::makeOption( '-1', '- Do not use an image -' ) );
		}
		if ( !$node->getAttribute( 'hide_default' ) ) {
			array_unshift( $options, mosHTML::makeOption( '', '- Use Default image -' ) );
		}

		return mosHTML::selectList( $options, ''. $control_name .'['. $name .']', 'class="inputbox"', 'value', 'text', $value );
	}

	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_textarea( $name, $value, &$node, $control_name ) {
 		$rows 	= $node->getAttribute( 'rows' );
 		$cols 	= $node->getAttribute( 'cols' );
 		// convert <br /> tags so they are not visible when editing
 		$value 	= str_replace( '<br />', "\n", $value );

 		return '<textarea name="'. $control_name .'['. $name .']" cols="'. $cols .'" rows="'. $rows .'" class="text_area">'. htmlspecialchars($value) .'</textarea>';
	}

	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_spacer( $name, $value, &$node, $control_name ) {
		if ( $value ) {
			return "<strong>".$value."</strong>";
		} else {
			return '<hr />';
		}
	}

	/**
	* @param string The name of the form element
	* @param string The value of the element
	* @param object The xml element for the parameter
	* @param string The control name
	* @return string The html for the element
	*/
	function _form_usergroup( $name, $value, &$node, $control_name ) {
		global $acl, $my;

		// ensure user can't add group higher than themselves
		$my_groups = $acl->get_object_groups( 'users', $my->id, 'ARO' );
		if (is_array( $my_groups ) && count( $my_groups ) > 0) {
			$ex_groups = $acl->get_group_children( $my_groups[0], 'ARO', 'RECURSE' );
		} else {
			$ex_groups = array();
		}

		$gtree = $acl->get_group_children_tree( null, 'USERS', false );

		// remove users 'above' me
		$i = 0;
		while ($i < count( $gtree )) {
			if (in_array( $gtree[$i]->value, $ex_groups )) {
				array_splice( $gtree, $i, 1 );
			} else {
				$i++;
			}
		}

		if ( ! $value ) {
			$value = $acl->get_group_id('Registered','ARO');
			// array_unshift( $gtree, mosHTML::makeOption( '0', '- Select User Group -' ) );
		}
		return mosHTML::selectList( $gtree, $control_name .'['. $name .']', 'class="inputbox"', 'value', 'text', $value );	//  size="10"
	}

	/**
	* special handling for textarea param
	*/
	function textareaHandling( &$txt ) {
		$total = count( $txt );
		for( $i=0; $i < $total; $i++ ) {
			if ( strstr( $txt[$i], "\n" ) ) {
				$txt[$i] = str_replace( "\n", '<br />', $txt[$i] );
			}
		}
		$txt = implode( "\n", $txt );

		return $txt;
	}
}

// ----- NO MORE CLASSES OR FUNCTIONS PASSED THIS POINT -----
// Post class declaration initialisations
// some version of PHP don't allow the instantiation of classes
// before they are defined

global $_PLUGINS;
/** @global cbPluginHandler $_PLUGINS */
$_PLUGINS = new cbPluginHandler();


?>