<?php
/**
* Core plugin with tab classes for: Portrait and Contact Tabs for handling the core CB tab api
* @version $Id: cb.core.php 438 2006-10-10 23:11:48Z beat $
* @package Community Builder
* @subpackage Page Title, Portrait, Contact tabs CB core plugin
* @author JoomlaJoe and Beat
* @copyright (C) JoomlaJoe and Beat, www.joomlapolis.com and various
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* Tab Class for User Profile Page title display
* @package Community Builder : cb.core pluing
* @subpackage Page Title tab CB core module
* @author JoomlaJoe and Beat
*/
class getPageTitleTab  extends cbTabHandler {
	/**
	* Constructor
	*/
	function getPageTitleTab() {
		$this->cbTabHandler();
	}
	/**
	* Generates the HTML to display the user profile tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayTab($tab,$user,$ui) {
		global $ueConfig;
		// Display user's name + "Profile Page"
		$params=$this->params;
		$title=getLangDefinition($params->get('title', '_UE_PROFILE_TITLE_TEXT'));
		$name = getNameFormat($user->name,$user->username,$ueConfig['name_format']);
		return '<div class="contentheading" id="cbProfileTitle">'.sprintf($title, $name)."</div>\n";
	}
}	// end class getPageTitleTab

/**
* Tab Class for User Profile Portrait/Avatar display
* @package Community Builder : cb.core pluing
* @subpackage Portrait tab CB core module
* @author JoomlaJoe and Beat
*/
class getPortraitTab  extends cbTabHandler {
	/**
	* Constructor
	*/
	function getContactTab() {
		$this->cbTabHandler();
	}
	/**
	* Generates the HTML to display the user profile tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayTab($tab,$user,$ui) {
		global $cbMyIsModerator, $ueConfig, $mosConfig_lang;
		// Display Avatar/Image:
		$return = "";
		if ($ueConfig['allowAvatar']=="1") {
			if($tab->description != null) $return .= "\t\t<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n";
			
			$name = htmlspecialchars(getNameFormat($user->name,$user->username,$ueConfig['name_format']));
			$return .= "\n\t\t\t\t<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" width=\"100%\"><tr>";
			$uimage=$user->avatar;
			if (file_exists("components/com_comprofiler/plugin/language/".$mosConfig_lang."/images"))
				$uimagepath="components/com_comprofiler/plugin/language/".$mosConfig_lang."/images/";
			else $uimagepath="components/com_comprofiler/plugin/language/default_language/images/";
			if($user->avatarapproved==0) $uimage=$uimagepath."pendphoto.jpg";
			elseif($user->avatar=='' || $user->avatar==null) $uimage=$uimagepath."nophoto.jpg";
			else $uimage="images/comprofiler/".$uimage;
			$return .= "<td align=\"center\" width=\"100%\"><img src=\"".sefRelToAbs($uimage)."\" alt=\"".$name."\" title=\"".$name."\" /></td>";
			if ($user->avatarapproved==0 && $cbMyIsModerator) {
				$uimage="images/comprofiler/".$user->avatar;
				$return .= "<td align=\"center\" width=\"100%\">"._UE_IMAGE_ADMIN_SUB.":<br /><br />"
						. "<img src=\"".$uimage."\" alt=\"".$name."\" title=\"".$name."\" /></td>";
			}
			$return .= "</tr></table>";
		}
		return $return;
	}
}	// end class getPortraitTab

/**
* Tab Class for User Profile EDIT Contacts special fields display
* @package Community Builder : cb.core pluing
* @subpackage Contact tab CB core module
* @author JoomlaJoe and Beat
*/
class getContactTab extends cbTabHandler {
	/**
	* Constructor
	*/
	function getContactTab() {
		$this->cbTabHandler();
	}
	/**
	* Generates the HTML to display the user profile tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayTab($tab,$user,$ui) {		
	}
	/**
	* Generates the HTML to display the user edit tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getEditTab($tab,$user,$ui) {
		global $ueConfig, $acl, $my, $mainframe;

		if (class_exists("JFactory")) {						// Joomla 1.5 :
			// if ($ui == 2) {
				//load common language files
				$lang =& JFactory::getLanguage();
				$lang->load("com_users");
			// }
		}
		$return="";
		$return .= "<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" width=\"100%\">\n";
		if($tab->description != null) $return .= "\t\t<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n";
		SWITCH($ueConfig["name_style"]) {
			case 2:
				$return .= "		<tr>\n";
				$return .= "			<td class=\"titleCell\">"._UE_YOUR_FNAME.":</td>\n";
				$return .= "			<td class=\"fieldCell\"><input class=\"inputbox\" type=\"text\" size=\"40\" mosReq=\"1\" mosLabel=\""._UE_YOUR_FNAME."\" name=\"firstname\" value=\"".htmlspecialchars($user->firstname)."\" />";
				$return .= getFieldIcons($ui, true,($ueConfig["name_format"]!=3));
				$return .= "		</td></tr>\n";
				$return .= "		<tr>\n";
				$return .= "			<td class=\"titleCell\">"._UE_YOUR_LNAME.":</td>\n";
				$return .= "			<td class=\"fieldCell\"><input class=\"inputbox\" type=\"text\" size=\"40\" mosReq=\"1\" mosLabel=\""._UE_YOUR_LNAME."\" name=\"lastname\" value=\"".htmlspecialchars($user->lastname)."\" />";
				$return .= getFieldIcons($ui, true,($ueConfig["name_format"]!=3));
				$return .= "		</td></tr>\n";
			break;
			case 3:
				$return .= "		<tr>\n";
				$return .= "			<td class=\"titleCell\">"._UE_YOUR_FNAME.":</td>\n";
				$return .= "			<td class=\"fieldCell\"><input class=\"inputbox\" type=\"text\" size=\"40\" mosReq=\"1\" mosLabel=\""._UE_YOUR_FNAME."\" name=\"firstname\" value=\"".htmlspecialchars($user->firstname)."\" />";
				$return .= getFieldIcons($ui, true,($ueConfig["name_format"]!=3));
				$return .= "		</td></tr>\n";
				$return .= "<tr>\n";
				$return .= "	<td class=\"titleCell\">"._UE_YOUR_MNAME.":</td>\n";
				$return .= "	<td class=\"fieldCell\"><input class=\"inputbox\" type=\"text\" size=\"40\" mosReq=\"0\" mosLabel=\""._UE_YOUR_MNAME."\" name=\"middlename\" value=\"".htmlspecialchars($user->middlename)."\" />\n";
				$return .= getFieldIcons($ui, false,($ueConfig["name_format"]!=3));
				$return .= "		</td></tr>\n";
				$return .= "		<tr>\n";
				$return .= "			<td class=\"titleCell\">"._UE_YOUR_LNAME.":</td>\n";
				$return .= "			<td class=\"fieldCell\"><input class=\"inputbox\" type=\"text\" size=\"40\" mosReq=\"1\" mosLabel=\""._UE_YOUR_LNAME."\" name=\"lastname\" value=\"".htmlspecialchars($user->lastname)."\" />";
				$return .= getFieldIcons($ui, true,($ueConfig["name_format"]!=3));
				$return .= "		</td></tr>\n";
			break;
			DEFAULT:
				$return .= "<tr>\n";
				$return .= "	<td class=\"titleCell\">"._UE_YOUR_NAME.":</td>\n";
				$return .= "	<td class=\"fieldCell\"><input class=\"inputbox\" type=\"text\" size=\"40\" name=\"name\" mosReq=\"1\" mosLabel=\"Name\"  value=\"".htmlspecialchars($user->name)."\" />";
				$return .= getFieldIcons($ui, true,($ueConfig["name_format"]!=3));
				$return .= "</td></tr>\n";
			break;
		}
		$return .= "		<tr>\n";
		$return .= "			<td class=\"titleCell\">"._UE_UNAME.":</td>\n";
		$return .= "			<td class=\"fieldCell\">";
		IF(($ueConfig["usernameedit"]==1) or ($user->username=="") or ($ui == 2)) { 
			$return .= "<input class=\"inputbox\" type=\"text\" size=\"40\" name=\"username\" value=\"".htmlspecialchars($user->username)."\" />"; 
			$return .= getFieldIcons($ui, true,($ueConfig["name_format"]!=1),sprintf( _VALID_AZ09, _UE_UNAME, 2 ) , _UE_UNAME.":");
		} else {
			$return .= $user->username;
			$return .= "<input class=\"inputbox\" type=\"hidden\" name=\"username\" value=\"".htmlspecialchars($user->username)."\" />";
		}
		$return .= "\n</td>\n</tr>\n";
	
		$return .= "<tr>\n";
		$return .= "	<td class=\"titleCell\">"._UE_EMAIL.":</td>\n";
		$return .= "	<td class=\"fieldCell\"><input class=\"inputbox\" type=\"text\" name=\"email\" mosReq=\"1\" mosLabel=\"Email\" value=\"".htmlspecialchars($user->email)."\" size=\"40\" />";
		$return .= getFieldIcons($ui, true,($ueConfig["allow_email_display"]==1 || $ueConfig["allow_email_display"]==2), _REGWARN_MAIL, _UE_EMAIL.":");
		$return .= "</td></tr>\n";
		$return .= "<tr>\n";
		$return .= "	<td class=\"titleCell\">"._UE_PASS.":</td>\n";
		$return .= "	<td class=\"fieldCell\"><input class=\"inputbox\" type=\"password\" size=\"40\" name=\"password\" value=\"\" autocomplete=\"off\" />";
		$return .= getFieldIcons($ui, false, false, sprintf( _VALID_AZ09, _UE_PASS, 6 ), _UE_PASS.":");
		$return .= "</td>\n</tr>\n";
		$return .= "<tr>\n";
		$return .= "	<td class=\"titleCell\">"._UE_VPASS.":</td>\n";
		$return .= "	<td class=\"fieldCell\"><input class=\"inputbox\" type=\"password\" size=\"40\" name=\"verifyPass\" autocomplete=\"off\" />";
		$return .= getFieldIcons($ui, false, false);
		$return .= "</td>\n</tr>\n";
		
		//Implementing Joomla's new user parameters such as editor
		$userParams = array();
		$userParams = $this->_getUserParams($ui, $user);		

		if ( ( count( $userParams ) > 0 ) && in_array( $mainframe->getCfg( "frontend_userparams" ), array( '1', null) ) ) {
			//Loop through each parameter and render it appropriately.
			foreach($userParams AS $userParam) {
				$return .= "<tr>\n";
				$return .= "<td class=\"titleCell\">" . $userParam[0] . ":</td>\n";
				$return .= "<td class=\"fieldCell\">" . $userParam[1];
				$return .= getFieldIcons($ui, false, false, (isset($userParam[2]) && class_exists("JText") ? JText::_($userParam[2]) : null), (isset($userParam[3]) && class_exists("JText") ? JText::_($userParam[3]) : null));
				$return .= "</td></tr>\n";	
			}
		}
		if($ui==2) {
			$canBlockUser	= $acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'user properties', 'block_user' );
			$canEmailEvents	= $acl->acl_check( 'workflow', 'email_events', 'users', $acl->get_group_name( $user->gid, 'ARO' ) )
							|| in_array( $user->gid, getParentGIDS( $ueConfig['imageApproverGid'] ) );	// allow also CB isModerator
			$lists = array();
			$user_group = strtolower( $acl->get_group_name( $user->gid, 'ARO' ) );
			if (( $user_group == 'super administrator' && $my->gid != 25) || ( $user->id == $my->id && $my->gid == 25)) {
				$lists['gid'] = "<input type=\"hidden\" mosReq=\"0\" name=\"gid\" value=\"$user->gid\" /><strong>Super Administrator</strong>";
			} else if ( $my->gid == 24 && $user->gid == 24 ) {
				$lists['gid'] = "<input type=\"hidden\" mosReq=\"0\" name=\"gid\" value=\"$user->gid\" /><strong>Administrator</strong>";
			} else {
				// ensure user can't add group higher than themselves
				$my_groups = $acl->get_object_groups( 'users', $my->id, 'ARO' );
				if (is_array( $my_groups ) && count( $my_groups ) > 0) {
					$ex_groups = $acl->get_group_children( $my_groups[0], 'ARO', 'RECURSE' );
				} else {
					$ex_groups = array();
				}
	
				$gtree = $acl->get_group_children_tree( null, 'USERS', false );
	
				// remove users 'above' me
				$i = 0;
				while ($i < count( $gtree )) {
					if (in_array( $gtree[$i]->value, $ex_groups )) {
						array_splice( $gtree, $i, 1 );
					} else {
						$i++;
					}
				}
	
				$lists['gid'] = mosHTML::selectList( $gtree, 'gid', 'size="11" mosReq="0"', 'value', 'text', $user->gid );
			}
	
			// make the select list for yes/no fields
			$yesno[] = mosHTML::makeOption( '0', 'No' );
			$yesno[] = mosHTML::makeOption( '1', 'Yes' );
	
			// build the html select list
			$lists['block'] = mosHTML::yesnoSelectList( 'block', 'class="inputbox" size="1"', $user->block );
			$lists['approved'] = mosHTML::yesnoSelectList( 'approved', 'class="inputbox" size="1"', $user->approved );
			$lists['confirmed'] = mosHTML::yesnoSelectList( 'confirmed', 'class="inputbox" size="1"', $user->confirmed );
			// build the html select list
			$lists['sendEmail'] = mosHTML::yesnoSelectList( 'sendEmail', 'class="inputbox" size="1"', $user->sendEmail );
			$return .= "<tr>\n";
			$return .= "  <td valign=\"top\" class=\"titleCell\">Group:</td>\n";
			$return .= "  <td class=\"fieldCell\">".$lists['gid']."</td>\n";
			$return .= "</tr>\n";
			if ($canBlockUser) {
				$return .= "<tr>\n";
				$return .= "  <td class=\"titleCell\">Block User</td>\n";
				$return .= "  <td class=\"fieldCell\">".$lists['block']."</td>\n";
				$return .= "</tr>\n";
				$return .= "<tr>\n";
				$return .= "  <td class=\"titleCell\">Approve User</td>\n";
				$return .= "  <td class=\"fieldCell\">".$lists['approved']."</td>\n";
				$return .= "</tr>\n";
				$return .= "<tr>\n";
				$return .= "  <td class=\"titleCell\">Confirm User</td>\n";
				$return .= "  <td class=\"fieldCell\">".$lists['confirmed']."</td>\n";
				$return .= "</tr>\n";
			}
			$return .= "<tr>\n";
			$return .= "  <td class=\"titleCell\">Receive Moderator Emails</td>\n";
			$return .= "  <td class=\"fieldCell\">";
			if ($canEmailEvents || $user->sendEmail) {
				$return .= $lists['sendEmail'];
			} else {
				$return .= "No (User's group-level doesn't allow this)<input type=\"hidden\" name=\"sendEmail\" value=\"0\" />";
			}
			$return .= "</td>\n</tr>\n";
			if( $user->id) {
				$return .= "<tr>\n";
				$return .= "   <td class=\"titleCell\">Register Date</td>\n";
				$return .= "   <td class=\"fieldCell\">".$user->registerDate."</td>\n";
				$return .= "</tr>\n";
				$return .= "<tr>\n";
				$return .= "   <td class=\"titleCell\">Last Visit Date</td>\n";
				$return .= "   <td class=\"fieldCell\">".$user->lastvisitDate."</td>\n";
				$return .= "</tr>\n";
			}
		}
		$return .= "</table>\n";
	
		return $return;
	}
	/**
	* Saves the user edit tab postdata into the tab's permanent storage
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @param array _POST data for saving edited tab content as generated with getEditTab
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function saveEditTab($tab, &$user, $ui, $postdata) {
		// this is (for now) handled in the core of CB...
	}

	/**
	* Retrieve joomla standard user parameters so that they can be displayed in user edit mode.
	* @param object user reflecting the user being edited
	* @return array of user parameter attributes (title,value)
	*/
	function _getUserParams($ui, $user,$name="cbparams") {
		global $mainframe;

		$result = array();	// in case not Joomla

		if (class_exists("JUser")) {						// Joomla 1.5 :
			$juser =& JUser::getInstance($user->id);
			$params =& $juser->getParameters();
			$params->loadSetupFile(JApplicationHelper::getPath( 'com_xml', 'com_users' ));
			// $result = $params->render( 'params' );
			if (is_callable(array("JParameter","getParams"))) {
				$result = $params->getParams( $name );	//BBB new API submited to Jinx 17.4.2006.
			} else {
				foreach ($params->_xml->param as $param) {	//BBB still needs core help... accessing private variable _xml .
					$result[] = $params->renderParam( $param, $name );
				}
			}
					
		} else {							
			if(file_exists($mainframe->getCfg('absolute_path') .'/administrator/components/com_users/users.class.php')){
				require_once( $mainframe->getCfg('absolute_path') .'/administrator/components/com_users/users.class.php' );		
			}
			if (class_exists('mosUserParameters')) {		// Joomla 1.0 :
				$file 	= $mainframe->getPath( 'com_xml', 'com_users' );
	
				$userParams =& new mosUserParameters( $user->params, $file, 'component' );
	
				if (isset($userParams->_path) && $userParams->_path) {						// Joomla 1.0
					if (!is_object( $userParams->_xmlElem )) {
						require_once( $mainframe->getCfg('absolute_path') . '/includes/domit/xml_domit_lite_include.php' );
		
						$xmlDoc = new DOMIT_Lite_Document();
						$xmlDoc->resolveErrors( true );
						if ($xmlDoc->loadXML( $userParams->_path, false, true )) {
							$root =& $xmlDoc->documentElement;
		
							$tagName = $root->getTagName();
							$isParamsFile = ($tagName == 'mosinstall' || $tagName == 'mosparams');
							if ($isParamsFile && $root->getAttribute( 'type' ) == $userParams->_type) {
								if ($params = &$root->getElementsByPath( 'params', 1 )) {
									$userParams->_xmlElem =& $params;
								}
							}
						}
					}
				}
				$result=array();
				
				if (isset($userParams->_xmlElem) && is_object( $userParams->_xmlElem )) {    // Joomla 1.0
					$element =& $userParams->_xmlElem;
					//$params = mosParseParams( $row->params );
					$userParams->_methods = get_class_methods( "mosUserParameters" );
					foreach ($element->childNodes as $param) {
						$result[] = $userParams->renderParam( $param, $name );
					}
				}
			}
		}
		return $result;
	}
	
}	// end class getContactTab

?>